]> git.ipfire.org Git - thirdparty/git.git/blob - git-submodule.sh
submodule: use "fetch" logic instead of custom remote discovery
[thirdparty/git.git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
11 or: $dashless [--quiet] init [--] [<path>...]
12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--[no-]single-branch] [--] [<path>...]
14 or: $dashless [--quiet] set-branch (--default|--branch <branch>) [--] <path>
15 or: $dashless [--quiet] set-url [--] <path> <newurl>
16 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
17 or: $dashless [--quiet] foreach [--recursive] <command>
18 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
19 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
20 OPTIONS_SPEC=
21 SUBDIRECTORY_OK=Yes
22 . git-sh-setup
23 . git-parse-remote
24 require_work_tree
25 wt_prefix=$(git rev-parse --show-prefix)
26 cd_to_toplevel
27
28 # Tell the rest of git that any URLs we get don't come
29 # directly from the user, so it can apply policy as appropriate.
30 GIT_PROTOCOL_FROM_USER=0
31 export GIT_PROTOCOL_FROM_USER
32
33 command=
34 branch=
35 force=
36 reference=
37 cached=
38 recursive=
39 init=
40 require_init=
41 files=
42 remote=
43 nofetch=
44 update=
45 prefix=
46 custom_name=
47 depth=
48 progress=
49 dissociate=
50 single_branch=
51 jobs=
52 recommend_shallow=
53
54 die_if_unmatched ()
55 {
56 if test "$1" = "#unmatched"
57 then
58 exit ${2:-1}
59 fi
60 }
61
62 isnumber()
63 {
64 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
65 }
66
67 # Given a full hex object ID, is this the zero OID?
68 is_zero_oid () {
69 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
70 }
71
72 # Sanitize the local git environment for use within a submodule. We
73 # can't simply use clear_local_git_env since we want to preserve some
74 # of the settings from GIT_CONFIG_PARAMETERS.
75 sanitize_submodule_env()
76 {
77 save_config=$GIT_CONFIG_PARAMETERS
78 clear_local_git_env
79 GIT_CONFIG_PARAMETERS=$save_config
80 export GIT_CONFIG_PARAMETERS
81 }
82
83 #
84 # Add a new submodule to the working tree, .gitmodules and the index
85 #
86 # $@ = repo path
87 #
88 # optional branch is stored in global branch variable
89 #
90 cmd_add()
91 {
92 # parse $args after "submodule ... add".
93 reference_path=
94 while test $# -ne 0
95 do
96 case "$1" in
97 -b | --branch)
98 case "$2" in '') usage ;; esac
99 branch=$2
100 shift
101 ;;
102 -f | --force)
103 force=$1
104 ;;
105 -q|--quiet)
106 GIT_QUIET=1
107 ;;
108 --progress)
109 progress=1
110 ;;
111 --reference)
112 case "$2" in '') usage ;; esac
113 reference_path=$2
114 shift
115 ;;
116 --reference=*)
117 reference_path="${1#--reference=}"
118 ;;
119 --dissociate)
120 dissociate=1
121 ;;
122 --name)
123 case "$2" in '') usage ;; esac
124 custom_name=$2
125 shift
126 ;;
127 --depth)
128 case "$2" in '') usage ;; esac
129 depth="--depth=$2"
130 shift
131 ;;
132 --depth=*)
133 depth=$1
134 ;;
135 --)
136 shift
137 break
138 ;;
139 -*)
140 usage
141 ;;
142 *)
143 break
144 ;;
145 esac
146 shift
147 done
148
149 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
150 then
151 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
152 fi
153
154 if test -n "$reference_path"
155 then
156 is_absolute_path "$reference_path" ||
157 reference_path="$wt_prefix$reference_path"
158
159 reference="--reference=$reference_path"
160 fi
161
162 repo=$1
163 sm_path=$2
164
165 if test -z "$sm_path"; then
166 sm_path=$(printf '%s\n' "$repo" |
167 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
168 fi
169
170 if test -z "$repo" || test -z "$sm_path"; then
171 usage
172 fi
173
174 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
175
176 # assure repo is absolute or relative to parent
177 case "$repo" in
178 ./*|../*)
179 test -z "$wt_prefix" ||
180 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
181
182 # dereference source url relative to parent's url
183 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
184 ;;
185 *:*|/*)
186 # absolute url
187 realrepo=$repo
188 ;;
189 *)
190 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
191 ;;
192 esac
193
194 # normalize path:
195 # multiple //; leading ./; /./; /../; trailing /
196 sm_path=$(printf '%s/\n' "$sm_path" |
197 sed -e '
198 s|//*|/|g
199 s|^\(\./\)*||
200 s|/\(\./\)*|/|g
201 :start
202 s|\([^/]*\)/\.\./||
203 tstart
204 s|/*$||
205 ')
206 if test -z "$force"
207 then
208 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
209 die "$(eval_gettext "'\$sm_path' already exists in the index")"
210 else
211 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
212 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
213 fi
214
215 if test -d "$sm_path" &&
216 test -z $(git -C "$sm_path" rev-parse --show-cdup 2>/dev/null)
217 then
218 git -C "$sm_path" rev-parse --verify -q HEAD >/dev/null ||
219 die "$(eval_gettext "'\$sm_path' does not have a commit checked out")"
220 fi
221
222 if test -z "$force"
223 then
224 dryerr=$(git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" 2>&1 >/dev/null)
225 res=$?
226 if test $res -ne 0
227 then
228 echo >&2 "$dryerr"
229 exit $res
230 fi
231 fi
232
233 if test -n "$custom_name"
234 then
235 sm_name="$custom_name"
236 else
237 sm_name="$sm_path"
238 fi
239
240 if ! git submodule--helper check-name "$sm_name"
241 then
242 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
243 fi
244
245 # perhaps the path exists and is already a git repo, else clone it
246 if test -e "$sm_path"
247 then
248 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
249 then
250 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
251 else
252 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
253 fi
254
255 else
256 if test -d ".git/modules/$sm_name"
257 then
258 if test -z "$force"
259 then
260 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
261 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
262 die "$(eval_gettextln "\
263 If you want to reuse this local git directory instead of cloning again from
264 \$realrepo
265 use the '--force' option. If the local git directory is not the correct repo
266 or you are unsure what this means choose another name with the '--name' option.")"
267 else
268 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
269 fi
270 fi
271 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
272 (
273 sanitize_submodule_env
274 cd "$sm_path" &&
275 # ash fails to wordsplit ${branch:+-b "$branch"...}
276 case "$branch" in
277 '') git checkout -f -q ;;
278 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
279 esac
280 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
281 fi
282 git config submodule."$sm_name".url "$realrepo"
283
284 git add --no-warn-embedded-repo $force "$sm_path" ||
285 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
286
287 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
288 git submodule--helper config submodule."$sm_name".url "$repo" &&
289 if test -n "$branch"
290 then
291 git submodule--helper config submodule."$sm_name".branch "$branch"
292 fi &&
293 git add --force .gitmodules ||
294 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
295
296 # NEEDSWORK: In a multi-working-tree world, this needs to be
297 # set in the per-worktree config.
298 if git config --get submodule.active >/dev/null
299 then
300 # If the submodule being adding isn't already covered by the
301 # current configured pathspec, set the submodule's active flag
302 if ! git submodule--helper is-active "$sm_path"
303 then
304 git config submodule."$sm_name".active "true"
305 fi
306 else
307 git config submodule."$sm_name".active "true"
308 fi
309 }
310
311 #
312 # Execute an arbitrary command sequence in each checked out
313 # submodule
314 #
315 # $@ = command to execute
316 #
317 cmd_foreach()
318 {
319 # parse $args after "submodule ... foreach".
320 while test $# -ne 0
321 do
322 case "$1" in
323 -q|--quiet)
324 GIT_QUIET=1
325 ;;
326 --recursive)
327 recursive=1
328 ;;
329 -*)
330 usage
331 ;;
332 *)
333 break
334 ;;
335 esac
336 shift
337 done
338
339 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
340 }
341
342 #
343 # Register submodules in .git/config
344 #
345 # $@ = requested paths (default to all)
346 #
347 cmd_init()
348 {
349 # parse $args after "submodule ... init".
350 while test $# -ne 0
351 do
352 case "$1" in
353 -q|--quiet)
354 GIT_QUIET=1
355 ;;
356 --)
357 shift
358 break
359 ;;
360 -*)
361 usage
362 ;;
363 *)
364 break
365 ;;
366 esac
367 shift
368 done
369
370 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} -- "$@"
371 }
372
373 #
374 # Unregister submodules from .git/config and remove their work tree
375 #
376 cmd_deinit()
377 {
378 # parse $args after "submodule ... deinit".
379 deinit_all=
380 while test $# -ne 0
381 do
382 case "$1" in
383 -f|--force)
384 force=$1
385 ;;
386 -q|--quiet)
387 GIT_QUIET=1
388 ;;
389 --all)
390 deinit_all=t
391 ;;
392 --)
393 shift
394 break
395 ;;
396 -*)
397 usage
398 ;;
399 *)
400 break
401 ;;
402 esac
403 shift
404 done
405
406 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} -- "$@"
407 }
408
409 is_tip_reachable () (
410 sanitize_submodule_env &&
411 cd "$1" &&
412 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
413 test -z "$rev"
414 )
415
416 fetch_in_submodule () (
417 sanitize_submodule_env &&
418 cd "$1" &&
419 if test $# -eq 3
420 then
421 echo "$3" | git fetch --stdin "$2"
422 elif test "$2" -ne ""
423 then
424 git fetch "$2"
425 else
426 git fetch
427 fi
428 )
429
430 #
431 # Update each submodule path to correct revision, using clone and checkout as needed
432 #
433 # $@ = requested paths (default to all)
434 #
435 cmd_update()
436 {
437 # parse $args after "submodule ... update".
438 while test $# -ne 0
439 do
440 case "$1" in
441 -q|--quiet)
442 GIT_QUIET=1
443 ;;
444 -v)
445 unset GIT_QUIET
446 ;;
447 --progress)
448 progress=1
449 ;;
450 -i|--init)
451 init=1
452 ;;
453 --require-init)
454 init=1
455 require_init=1
456 ;;
457 --remote)
458 remote=1
459 ;;
460 -N|--no-fetch)
461 nofetch=1
462 ;;
463 -f|--force)
464 force=$1
465 ;;
466 -r|--rebase)
467 update="rebase"
468 ;;
469 --reference)
470 case "$2" in '') usage ;; esac
471 reference="--reference=$2"
472 shift
473 ;;
474 --reference=*)
475 reference="$1"
476 ;;
477 --dissociate)
478 dissociate=1
479 ;;
480 -m|--merge)
481 update="merge"
482 ;;
483 --recursive)
484 recursive=1
485 ;;
486 --checkout)
487 update="checkout"
488 ;;
489 --recommend-shallow)
490 recommend_shallow="--recommend-shallow"
491 ;;
492 --no-recommend-shallow)
493 recommend_shallow="--no-recommend-shallow"
494 ;;
495 --depth)
496 case "$2" in '') usage ;; esac
497 depth="--depth=$2"
498 shift
499 ;;
500 --depth=*)
501 depth=$1
502 ;;
503 -j|--jobs)
504 case "$2" in '') usage ;; esac
505 jobs="--jobs=$2"
506 shift
507 ;;
508 --jobs=*)
509 jobs=$1
510 ;;
511 --single-branch)
512 single_branch="--single-branch"
513 ;;
514 --no-single-branch)
515 single_branch="--no-single-branch"
516 ;;
517 --)
518 shift
519 break
520 ;;
521 -*)
522 usage
523 ;;
524 *)
525 break
526 ;;
527 esac
528 shift
529 done
530
531 if test -n "$init"
532 then
533 cmd_init "--" "$@" || return
534 fi
535
536 {
537 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
538 ${progress:+"--progress"} \
539 ${wt_prefix:+--prefix "$wt_prefix"} \
540 ${prefix:+--recursive-prefix "$prefix"} \
541 ${update:+--update "$update"} \
542 ${reference:+"$reference"} \
543 ${dissociate:+"--dissociate"} \
544 ${depth:+--depth "$depth"} \
545 ${require_init:+--require-init} \
546 $single_branch \
547 $recommend_shallow \
548 $jobs \
549 -- \
550 "$@" || echo "#unmatched" $?
551 } | {
552 err=
553 while read -r quickabort sha1 just_cloned sm_path
554 do
555 die_if_unmatched "$quickabort" "$sha1"
556
557 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
558
559 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
560
561 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
562
563 if test $just_cloned -eq 1
564 then
565 subsha1=
566 else
567 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
568 git rev-parse --verify HEAD) ||
569 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
570 fi
571
572 if test -n "$remote"
573 then
574 branch=$(git submodule--helper remote-branch "$sm_path")
575 if test -z "$nofetch"
576 then
577 # Fetch remote before determining tracking $sha1
578 fetch_in_submodule "$sm_path" $depth ||
579 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
580 fi
581 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
582 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
583 git rev-parse --verify "${remote_name}/${branch}") ||
584 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
585 fi
586
587 if test "$subsha1" != "$sha1" || test -n "$force"
588 then
589 subforce=$force
590 # If we don't already have a -f flag and the submodule has never been checked out
591 if test -z "$subsha1" && test -z "$force"
592 then
593 subforce="-f"
594 fi
595
596 if test -z "$nofetch"
597 then
598 # Run fetch only if $sha1 isn't present or it
599 # is not reachable from a ref.
600 is_tip_reachable "$sm_path" "$sha1" ||
601 fetch_in_submodule "$sm_path" $depth ||
602 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'; trying to directly fetch \$sha1:")"
603
604 # Now we tried the usual fetch, but $sha1 may
605 # not be reachable from any of the refs
606 is_tip_reachable "$sm_path" "$sha1" ||
607 fetch_in_submodule "$sm_path" $depth "$sha1" ||
608 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
609 fi
610
611 must_die_on_failure=
612 case "$update_module" in
613 checkout)
614 command="git checkout $subforce -q"
615 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
616 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
617 ;;
618 rebase)
619 command="git rebase ${GIT_QUIET:+--quiet}"
620 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
621 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
622 must_die_on_failure=yes
623 ;;
624 merge)
625 command="git merge ${GIT_QUIET:+--quiet}"
626 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
627 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
628 must_die_on_failure=yes
629 ;;
630 !*)
631 command="${update_module#!}"
632 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
633 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
634 must_die_on_failure=yes
635 ;;
636 *)
637 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
638 esac
639
640 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
641 then
642 say "$say_msg"
643 elif test -n "$must_die_on_failure"
644 then
645 die_with_status 2 "$die_msg"
646 else
647 err="${err};$die_msg"
648 continue
649 fi
650 fi
651
652 if test -n "$recursive"
653 then
654 (
655 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
656 wt_prefix=
657 sanitize_submodule_env
658 cd "$sm_path" &&
659 eval cmd_update
660 )
661 res=$?
662 if test $res -gt 0
663 then
664 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
665 if test $res -ne 2
666 then
667 err="${err};$die_msg"
668 continue
669 else
670 die_with_status $res "$die_msg"
671 fi
672 fi
673 fi
674 done
675
676 if test -n "$err"
677 then
678 OIFS=$IFS
679 IFS=';'
680 for e in $err
681 do
682 if test -n "$e"
683 then
684 echo >&2 "$e"
685 fi
686 done
687 IFS=$OIFS
688 exit 1
689 fi
690 }
691 }
692
693 #
694 # Configures a submodule's default branch
695 #
696 # $@ = requested path
697 #
698 cmd_set_branch() {
699 default=
700 branch=
701
702 while test $# -ne 0
703 do
704 case "$1" in
705 -q|--quiet)
706 # we don't do anything with this but we need to accept it
707 ;;
708 -d|--default)
709 default=1
710 ;;
711 -b|--branch)
712 case "$2" in '') usage ;; esac
713 branch=$2
714 shift
715 ;;
716 --)
717 shift
718 break
719 ;;
720 -*)
721 usage
722 ;;
723 *)
724 break
725 ;;
726 esac
727 shift
728 done
729
730 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper set-branch ${GIT_QUIET:+--quiet} ${branch:+--branch "$branch"} ${default:+--default} -- "$@"
731 }
732
733 #
734 # Configures a submodule's remote url
735 #
736 # $@ = requested path, requested url
737 #
738 cmd_set_url() {
739 while test $# -ne 0
740 do
741 case "$1" in
742 -q|--quiet)
743 GIT_QUIET=1
744 ;;
745 --)
746 shift
747 break
748 ;;
749 -*)
750 usage
751 ;;
752 *)
753 break
754 ;;
755 esac
756 shift
757 done
758
759 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper set-url ${GIT_QUIET:+--quiet} -- "$@"
760 }
761
762 #
763 # Show commit summary for submodules in index or working tree
764 #
765 # If '--cached' is given, show summary between index and given commit,
766 # or between working tree and given commit
767 #
768 # $@ = [commit (default 'HEAD'),] requested paths (default all)
769 #
770 cmd_summary() {
771 summary_limit=-1
772 for_status=
773 diff_cmd=diff-index
774
775 # parse $args after "submodule ... summary".
776 while test $# -ne 0
777 do
778 case "$1" in
779 --cached)
780 cached="$1"
781 ;;
782 --files)
783 files="$1"
784 ;;
785 --for-status)
786 for_status="$1"
787 ;;
788 -n|--summary-limit)
789 summary_limit="$2"
790 isnumber "$summary_limit" || usage
791 shift
792 ;;
793 --summary-limit=*)
794 summary_limit="${1#--summary-limit=}"
795 isnumber "$summary_limit" || usage
796 ;;
797 --)
798 shift
799 break
800 ;;
801 -*)
802 usage
803 ;;
804 *)
805 break
806 ;;
807 esac
808 shift
809 done
810
811 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper summary ${prefix:+--prefix "$prefix"} ${files:+--files} ${cached:+--cached} ${for_status:+--for-status} ${summary_limit:+-n $summary_limit} -- "$@"
812 }
813 #
814 # List all submodules, prefixed with:
815 # - submodule not initialized
816 # + different revision checked out
817 #
818 # If --cached was specified the revision in the index will be printed
819 # instead of the currently checked out revision.
820 #
821 # $@ = requested paths (default to all)
822 #
823 cmd_status()
824 {
825 # parse $args after "submodule ... status".
826 while test $# -ne 0
827 do
828 case "$1" in
829 -q|--quiet)
830 GIT_QUIET=1
831 ;;
832 --cached)
833 cached=1
834 ;;
835 --recursive)
836 recursive=1
837 ;;
838 --)
839 shift
840 break
841 ;;
842 -*)
843 usage
844 ;;
845 *)
846 break
847 ;;
848 esac
849 shift
850 done
851
852 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} -- "$@"
853 }
854 #
855 # Sync remote urls for submodules
856 # This makes the value for remote.$remote.url match the value
857 # specified in .gitmodules.
858 #
859 cmd_sync()
860 {
861 while test $# -ne 0
862 do
863 case "$1" in
864 -q|--quiet)
865 GIT_QUIET=1
866 shift
867 ;;
868 --recursive)
869 recursive=1
870 shift
871 ;;
872 --)
873 shift
874 break
875 ;;
876 -*)
877 usage
878 ;;
879 *)
880 break
881 ;;
882 esac
883 done
884
885 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} -- "$@"
886 }
887
888 cmd_absorbgitdirs()
889 {
890 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
891 }
892
893 # This loop parses the command line arguments to find the
894 # subcommand name to dispatch. Parsing of the subcommand specific
895 # options are primarily done by the subcommand implementations.
896 # Subcommand specific options such as --branch and --cached are
897 # parsed here as well, for backward compatibility.
898
899 while test $# != 0 && test -z "$command"
900 do
901 case "$1" in
902 add | foreach | init | deinit | update | set-branch | set-url | status | summary | sync | absorbgitdirs)
903 command=$1
904 ;;
905 -q|--quiet)
906 GIT_QUIET=1
907 ;;
908 -b|--branch)
909 case "$2" in
910 '')
911 usage
912 ;;
913 esac
914 branch="$2"; shift
915 ;;
916 --cached)
917 cached="$1"
918 ;;
919 --)
920 break
921 ;;
922 -*)
923 usage
924 ;;
925 *)
926 break
927 ;;
928 esac
929 shift
930 done
931
932 # No command word defaults to "status"
933 if test -z "$command"
934 then
935 if test $# = 0
936 then
937 command=status
938 else
939 usage
940 fi
941 fi
942
943 # "-b branch" is accepted only by "add" and "set-branch"
944 if test -n "$branch" && (test "$command" != add || test "$command" != set-branch)
945 then
946 usage
947 fi
948
949 # "--cached" is accepted only by "status" and "summary"
950 if test -n "$cached" && test "$command" != status && test "$command" != summary
951 then
952 usage
953 fi
954
955 "cmd_$(echo $command | sed -e s/-/_/g)" "$@"